#include <bits/stdc++.h>
#define FAST {ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);}
#define FILES {freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);}
#define ll long long
#define ull unsigned long long
#define pqueue priority_queue
#define pb push_back
#define fi first
#define se second
#define ld long double
#define pii pair<int,int>
#define pll pair<long long,long long>
#define all(a) (a).begin(), (a).end()
#define mp make_pair 
using namespace std;
/*
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;

#define ordered_set tree<pll, null_type,less<pll>, rb_tree_tag,tree_order_statistics_node_update>
*/
// order_of_key -> # less than k
// find_by_order -> k-th element
// pq max element                                          

void files() {
    #ifndef ONLINE_JUDGE
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
}

const double eps = 0.00000001;
const ll NMAX = 200010;
const ll inf = 1e16;
const ll modi = 1e9+7;

vector<pii>al[NMAX];

void solve() {
    int n,m;
    cin >> n >> m;
    for (int i = 0 ; i < m ; i++ ) {
        int a,b,t;
        cin >> a >> b >> t;
        al[a].pb({b,t});
        al[b].pb({a,t});
    }
    int aa,v;
    cin >> aa >> v;
    pqueue<pair<int,pii>>pq;
    vector<bool>visited(NMAX,false);
    pq.push({0,{aa,0}});
    while(pq.size()) {
        int dist = -pq.top().fi;
        int nd = pq.top().se.fi;
        int state = pq.top().se.se;
        //cout << dist << endl;
        pq.pop();
        if ( visited[nd] ) continue;
        visited[nd] = true;
        if ( nd == v ) {
            cout << dist << endl;
            return;
        }

        for (auto u : al[nd]) {
            pq.push({-(dist + abs(u.se-state)), {u.fi,u.se}});
        }
    }

    cout << -1 << endl;
}

int main () { 
    FAST
    int t=1;

    /*
    cin >> t;
    //*/

    int i = 1;
    while(t--) {
        //cout << "Case #" << i++ << ": " ;
        solve();
    }
}